/*
 * [ChangeYourPasswordsDay.java]
 *
 * Summary: Day to change all your passwords.
 *
 * Copyright: (c) 1999-2017 Roedy Green, Canadian Mind Products, http://mindprod.com
 *
 * Licence: This software may be copied and used freely for any purpose but military.
 *          http://mindprod.com/contact/nonmil.html
 *
 * Requires: JDK 1.8+
 *
 * Created with: JetBrains IntelliJ IDEA IDE http://www.jetbrains.com/idea/
 *
 * Version History:
 *  1.0 2009-09-15 initial version
 */
package com.mindprod.holidays;

import com.mindprod.common18.BigDate;

/**
 * Day to change all your passwords.
 *
 * @author Roedy Green, Canadian Mind Products
 * @version 1.0 2009-09-15 initial version
 * @since 2009
 */
public final class ChangeYourPasswordsDay extends HolInfo
    {
    /**
     * @inheritDoc
     */
    public String getAuthority()
        {
        return "http://blogs.educationau.edu.au/ksmith/2009/06/05/national-change-your-password-day-5-june/";
        }

    /**
     * @inheritDoc
     */
    public int getFirstYear( int base )
        {
        // first time 2009-06-05
        return 2009;
        }

    /**
     * @inheritDoc
     */
    public String getName()
        {
        return "Change Your Passwords Day";
        }

    /**
     * @inheritDoc
     */
    public String getRule()
        {
        return "First Friday in June";
        }

    /**
     * @inheritDoc
     */
    public int when( int year, boolean shift, int base )
        {
        if ( !isYearValid( year, base ) )
            {
            return BigDate.NULL_ORDINAL;
            }
        return BigDate.ordinalOfnthXXXDay( 1, BigDate.FRIDAY, year, BigDate.SEP );
        } // end when.
    }
